//~---------------------------------------------------------------------------//
//                        __      __                  __   __                 //
//                .-----.|  |_.--|  |.--------.---.-.|  |_|  |_               //
//                |__ --||   _|  _  ||        |  _  ||   _|   _|              //
//                |_____||____|_____||__|__|__|___._||____|____|              //
//                                                                            //
//  File      : Utils.h                                                       //
//  Project   : ssp                                                           //
//  Date      : Sep 15, 2019                                                  //
//  License   : GPLv3                                                         //
//  Author    : stdmatt <stdmatt@pixelwizards.io>                             //
//  Copyright : stdmatt - 2019                                                //
//                                                                            //
//  Description :                                                             //
//                                                                            //
//---------------------------------------------------------------------------~//

#pragma once
// std
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

//----------------------------------------------------------------------------//
// Macros                                                                     //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
#define ASSERT(_exp_, _fmt_, ...)       \
    do {                                \
        if(!(_exp_)) {                  \
            printf(_fmt_, #__VA_ARGS__); \
            abort();                    \
        }                               \
    } while(0)

//------------------------------------------------------------------------------
#define VERIFY(_exp_, _fmt_, ...)       \
    do {                                \
        if(!(_exp_)) {                  \
            printf(_fmt_, __VA_ARGS__); \
            exit(1);                    \
        }                               \
    } while(0)

//------------------------------------------------------------------------------
#define SAFE_DELETE(_ptr_)   \
    do {                     \
        if(_ptr_) {          \
            delete _ptr_;    \
            _ptr_ = nullptr; \
        }                    \
    } while(0)

//------------------------------------------------------------------------------
#define SAFE_FREE(_ptr_)        \
    do {                        \
        if(_ptr_) {             \
            free((void*)_ptr_); \
            _ptr_ = nullptr;    \
        }                       \
    } while(0)


//------------------------------------------------------------------------------
struct Rect
{
    uint32_t x, y, w, h;
}; // struct Rect
